#include <iostream>
#include <fstream>
#include <cstdlib> // exit()
#include <vector>
#include <string.h>
#include <sstream>
#include <windows.h>

#define up = "up"
#define upnD = "up and down"
#define down = "down"
#define right_ = "right"
#define left_ = "left"
#define straight = "straight"
#define around = "around"
#define add = "+"
#define subtract = "-"
#define addSubtract = "+-"

const std::string gF[] = {"A_gFlat_part_1_AND_green:", // right
                          "A_gFlat_part_1_AND_red:",   // up
                          "A_gFlat_part_1_AND_cyan:",  // left
                          "A_gFlat_part_1_AND_red:",   // up
                          "A_gFlat_part_2_AND_green:", // right
                          "A_gFlat_part_2_AND_red:",   // up
                          "A_gFlat_part_3_XOR_red:",   // up
                          "A_gFlat_part_4_OR_cyan:",   // left
                          "A_gFlat_part_4_OR_red:"};   // up

const std::string dF[] = {"B_dFlat_part_1_AND_red:", // up
                          "B_dFlat_part_1_AND_blue:",   // straight
                          "B_dFlat_part_1_AND_red:",  // up
                          "B_dFlat_part_1_AND_cyan:",   // left
                          "B_dFlat_part_2_AND_red:", // up
                          "B_dFlat_part_2_AND_cyan:",   // left
                          "B_dFlat_part_3_XOR_blue:",   // straight
                          "B_dFlat_part_4_OR_red:",   // up
                          "B_dFlat_part_4_OR_cyan:"};   // left

const std::string aF[] = {"C_aFlat_part_1_AND_cyan:", // left
                          "C_aFlat_part_1_AND_yellow:",   // down
                          "C_aFlat_part_1_AND_blue:",  // straight
                          "C_aFlat_part_1_AND_red:",   // up
                          "C_aFlat_part_2_AND_cyan:", // left
                          "C_aFlat_part_2_AND_red:",   // up
                          "C_aFlat_part_3_XOR_yellow:",   // down
                          "C_aFlat_part_4_OR_blue:",   // straight
                          "C_aFlat_part_4_OR_red:"};   // up

const std::string eF[] = {"D_eFlat_part_1_AND_red:", // up
                          "D_eFlat_part_1_AND_red:",   // up
                          "D_eFlat_part_1_AND_yellow:",  // down
                          "D_eFlat_part_1_AND_blue:",   // straight
                          "D_eFlat_part_2_AND_red:", // up
                          "D_eFlat_part_2_AND_blue:",   // straight
                          "D_eFlat_part_3_XOR_red:",   // up
                          "D_eFlat_part_4_OR_yellow:",   // down
                          "D_eFlat_part_4_OR_blue:"};   // straight


const std::string bF[] = {"E_bFlat_part_1_AND_blue:", // straight
                          "E_bFlat_part_1_AND_green:",   // right
                          "E_bFlat_part_1_AND_red:",  // up
                          "E_bFlat_part_1_AND_yellow:",   // down
                          "E_bFlat_part_2_AND_blue:", // straight
                          "E_bFlat_part_2_AND_yellow:",   // down
                          "E_bFlat_part_3_XOR_green:",   // right
                          "E_bFlat_part_4_OR_red:",   // up
                          "E_bFlat_part_4_OR_yellow:"};   // down

const std::string F[] = {"F_part_1_AND_yellow:", // down
                          "F_part_1_AND_red:",   // up
                          "F_part_1_AND_green:",  // right
                          "F_part_1_AND_red:",   // up
                          "F_part_2_AND_yellow:", // down
                          "F_part_2_AND_red:",   // up
                          "F_part_3_XOR_red:",   // up
                          "F_part_4_OR_green:",   // right
                          "F_part_4_OR_red:"};   // up

const std::string C[] = {"G_C_part_1_AND_red:", // up
                          "G_C_part_1_AND_blue:",   // straight
                          "G_C_part_1_AND_red:",  // up
                          "G_C_part_1_AND_green:",   // right
                          "G_C_part_2_AND_red:", // up
                          "G_C_part_2_AND_green:",   // right
                          "G_C_part_3_XOR_blue:",   // straight
                          "G_C_part_4_OR_red:",   // up
                          "G_C_part_4_OR_green:"};   // right

const std::string G[] = {"H_G_part_1_AND_green:", // right
                          "H_G_part_1_AND_orange:",   // up and down
                          "H_G_part_1_AND_blue:",  // straight
                          "H_G_part_1_AND_red:",   // up
                          "H_G_part_2_AND_green:", // right
                          "H_G_part_2_AND_red:",   // up
                          "H_G_part_3_XOR_orange:",   // up and down
                          "H_G_part_4_OR_blue:",   // straight
                          "H_G_part_4_OR_red:"};   // up

const std::string D[] = {"I_part_1_AND_red:", // up
                          "I_part_1_AND_violet:",   // around
                          "I_part_1_AND_orange:",  // up and down
                          "I_part_1_AND_blue:",   // straight
                          "I_part_2_AND_red:", // up
                          "I_part_2_AND_blue:",   // straight
                          "I_part_3_XOR_violet:",   // around
                          "I_part_4_OR_orange:",   // up and down
                          "I_part_4_OR_blue:"};   // straight

const std::string A[] = {"J_A_part_1_AND_blue:", // straight
                          "J_A_part_1_AND_green:",   // right
                          "J_A_part_1_AND_violet:",  // around
                          "J_A_part_1_AND_orange:",   // up and down
                          "J_A_part_2_AND_blue:", // straight
                          "J_A_part_2_AND_orange:",   // up and down
                          "J_A_part_3_XOR_green:",   // right
                          "J_A_part_4_OR_violet:",   // around
                          "J_A_part_4_OR_orange:"};   // up and down

const std::string E[] = {"K_E_part_1_AND_orange:", // up and down
                          "K_E_part_1_AND_red:",   // up
                          "K_E_part_1_AND_green:",  // right
                          "K_E_part_1_AND_violet:",   // around
                          "K_E_part_2_AND_orange:", // up and down
                          "K_E_part_2_AND_violet:",   // around
                          "K_E_part_3_XOR_red:",   // up
                          "K_E_part_4_OR_green:",   // right
                          "K_E_part_4_OR_violet:"};   // around

const std::string B[] = {"L_B_part_1_AND_violet:", // around
                          "L_B_part_1_AND_cyan:",   // left
                          "L_B_part_1_AND_red:",  // up
                          "L_B_part_1_AND_green:",   // right
                          "L_B_part_2_AND_violet:", // around
                          "L_B_part_2_AND_green:",   // right
                          "L_B_part_3_XOR_cyan:",   // left
                          "L_B_part_4_OR_red:",   // up
                          "L_B_part_4_OR_green:"};   // right

// I use this in the 12 pattern finding functions, to compare stings.
const std::string frequencies[] = {"466.16", // blue, keAS
                                   "415.3",  // cyan, keGS
                                   "415.3",  // cyan, keGS
                                   "415.3",  // cyan, keGS
                                   "415.3",  // cyan, keGS
                                   "415.3",  // cyan, keGS
                                   "349.23", // yellow, keF
                                   "277.18", // red, keCS
                                   "349.23", // yellow, keF
                                   "440",    // blue, keA
                                   "392",    // green, keG
                                   "261.63", // red, keC
                                   "261.63", // red, keC
                                   "349.23", // yellow, keF
                                   "493.88", // violet, keB
                                   "261.63", // red, keC
                                   "261.63", // red, keC
                                   "329.63", // orange, keE
                                   "311.13", // red, keDS
                                   "415.3",  // cyan, keGS
                                   "293.66", // red, keD
                                   "415.3",  // cyan, keGS
                                   "311.13", // red, keDS
                                   "369.99", // green, keFS
                                   "392",    // green, keG
                                   "392"};   // green, keG

using namespace std;

int count_up = 0;
int count_upnD = 0;
int count_down = 0;
int count_right_ = 0;
int count_left_ = 0;
int count_straight = 0;
int count_around = 0;

// This is used for playing sound
enum EFrequency {
	keRest = 0,
	keC = 262, keCS = 277, keD = 294, keDS = 311, keE = 330, keF = 349,
	keFS = 370, keG = 392, keGS = 415, keA = 440, keAS = 466, keB = 494,
};
enum EDuration {
	ke16th = 200, ke8th = (ke16th << 1), keQuart = (ke8th << 1),
	keHalf = (keQuart << 1), keWhole = (keQuart << 1)
};

class CNote {
public:
	CNote(unsigned int uiFrequency, unsigned int uiDuration)
		: muiFrequency(uiFrequency), muiDuration(uiDuration) {}
	void Play () {
		if (muiFrequency > 0) {
			Beep(muiFrequency, muiDuration);
		} else {
			Sleep(muiDuration);
		}
	}
	unsigned int muiFrequency;
	unsigned int muiDuration;
};

class CMelody {
public:
	void AddNote(unsigned int uiFrequency, unsigned int uiDuration) {
		mqNotes.push_back(CNote(uiFrequency, uiDuration));
	}
	void Play () {
		std::vector<CNote>::iterator qIter;
		for (qIter = mqNotes.begin(); qIter != mqNotes.end(); ++qIter) {
			qIter->Play();
		}
	}
	std::vector<CNote> mqNotes;
};

void findMatch(){
    string temp1;
    string temp2;
    string temp3;
    string temp4;
    string temp5;
    string temp6;
    string temp7;
    string temp8;
    string dataBaseSentence1;
    string dataBaseSentence2;
    string dataBaseSentence3;
    string dataBaseSentence4;
    string dataBaseSentence5;
    string dataBaseSentence6;
    string dataBaseSentence7;
    int count1 = 0;
    int count2 = 0;
    int count3 = 0;
    int count4 = 0;
    int count5 = 0;
    int count6 = 0;
    int count7 = 0;
    int countResult = 0;
    vector<string> text_file1;
    vector<string> text_file2;
    vector<string> text_file3;
    vector<string> text_file4;
    vector<string> text_file5;
    vector<string> text_file6;
    vector<string> text_file7;

    std::ifstream hfin1("holdSentence.txt", fstream::app), fin2("holdDatabase.txt", fstream::app);
    if (!hfin1 || !fin2) { std::cerr<<"file error\n"; std::exit(1); }

    getline( hfin1, temp1 );

    while( getline( fin2, temp2 ) ){

        for (unsigned int a=0;a < temp2.length();a++){

            if(temp2[a] == '1'){

                if ( strcmp(&temp1[a], &temp2[a]) == 0 ){
                    count1++;
                }
                if(count1 > 0 && countResult == 0 && (temp1 != temp2)){
                    dataBaseSentence1 = temp2;
                    countResult++;
                }
            }
        }

        text_file1.push_back( temp2 );
    }

    hfin1.close();
    fin2.close();

    countResult = 0;

    std::ifstream hfin2("holdSentence.txt", fstream::app), fin3("holdDatabase.txt", fstream::app);
    if (!hfin2 || !fin3) { std::cerr<<"file error\n"; std::exit(1); }

    getline( hfin2, temp1 );

    while( getline( fin3, temp3 ) ){

        for (unsigned int a=0;a < temp3.length();a++){

            if(temp3[a] == '2'){

                if ( strcmp(&temp1[a], &temp3[a]) == 0 ){
                    count2++;
                }
                if(count2 > 0 && countResult == 0 && (temp1 != temp3)){
                    dataBaseSentence2 = temp3;
                    countResult++;
                }
            }
        }

        text_file2.push_back( temp3 );
    }

    hfin2.close();
    fin3.close();

    countResult = 0;

    std::ifstream hfin3("holdSentence.txt", fstream::app), fin4("holdDatabase.txt", fstream::app);
    if (!hfin3 || !fin4) { std::cerr<<"file error\n"; std::exit(1); }

    getline(hfin3, temp1);

    while( getline( fin4, temp4 ) ){

        for (unsigned int a=0;a < temp4.length();a++){

            if(temp4[a] == '3'){

                if ( strcmp(&temp1[a],&temp4[a]) == 0){
                    count3++;
                }
                if(count3 > 0 && countResult == 0 && (temp1 != temp4)){
                    dataBaseSentence3 = temp4;
                    countResult++;
                }
            }
        }

        text_file3.push_back( temp4 );
    }

    hfin3.close();
    fin4.close();

    countResult = 0;

    std::ifstream hfin4("holdSentence.txt", fstream::app), fin5("holdDatabase.txt", fstream::app);
    if (!hfin4 || !fin5) { std::cerr<<"file error\n"; std::exit(1); }

    getline( hfin4, temp1 );

    while( getline( fin5, temp5 ) ){

        for (unsigned int a=0;a < temp5.length();a++){

            if(temp5[a] == '4'){

                if ( strcmp(&temp1[a], &temp5[a]) ==0 ){
                    count4++;
                }
                if(count4 > 0 && countResult == 0 && (temp1 != temp5)){
                    dataBaseSentence4 = temp5;
                    countResult++;
                }
            }
        }

        text_file4.push_back( temp5 );
    }

    hfin4.close();
    fin5.close();

    countResult = 0;

    std::ifstream hfin5("holdSentence.txt", fstream::app), fin6("holdDatabase.txt", fstream::app);
    if (!hfin5 || !fin6) { std::cerr<<"file error\n"; std::exit(1); }

    getline( hfin5, temp1 );

    while( getline( fin6, temp6 ) ){

        for (unsigned int a=0;a < temp6.length();a++){

            if(temp6[a] == '5'){

                if ( strcmp(&temp1[a],&temp6[a]) == 0 ){
                    count5++;
                }
                if(count5 > 0 && countResult == 0 && (temp1 != temp6)){
                    dataBaseSentence5 = temp6;
                    countResult++;
                }
            }
        }

        text_file5.push_back( temp6 );
    }

    hfin5.close();
    fin6.close();

    countResult = 0;

    std::ifstream hfin6("holdSentence.txt", fstream::app), fin7("holdDatabase.txt", fstream::app);
    if (!hfin6 || !fin7) { std::cerr<<"file error\n"; std::exit(1); }

    getline( hfin6, temp1 );

    while( getline( fin7, temp7 ) ){

        for (unsigned int a=0;a < temp7.length();a++){

            if(temp7[a] == '6'){

                if ( strcmp(&temp1[a], &temp7[a]) == 0 ){
                    count6++;
                }
                if(count6 > 0 && countResult == 0 && (temp1 != temp7)){
                    dataBaseSentence6 = temp7;
                    countResult++;
                }
            }
        }

        text_file6.push_back( temp7 );
    }

    hfin6.close();
    fin7.close();

    countResult = 0;

    std::ifstream hfin7("holdSentence.txt", fstream::app), fin8("holdDatabase.txt", fstream::app);
    if (!hfin7 || !fin8) { std::cerr<<"file error\n"; std::exit(1); }

    getline( hfin7, temp1 );

    while( getline( fin8, temp8 ) ){

        for (unsigned int a=0;a < temp8.length();a++){

            if(temp8[a] == '7'){

                if ( strcmp(&temp1[a], &temp8[a]) ){
                    count7++;
                }
                if(count7 > 0 && countResult == 0 && (temp1 != temp8)){
                    dataBaseSentence7 = temp8;
                    countResult++;
                }
            }
        }

        text_file7.push_back( temp8 );
    }

    hfin7.close();
    fin8.close();

    countResult = 0;

    if(count1 > count2 && (count1 > count3) && (count1 > count4) && (count1 > count5) && (count1 > count6) && (count1 > count7))
        cout << endl << endl << "Program response;" << endl << dataBaseSentence1;
    else if(count2 > count1 && (count2 > count3) && (count2 > count4) && (count2 > count5) && (count2 > count6) && (count2 > count7))
        cout << endl << endl << "Program response;" << endl << dataBaseSentence2;
    else if(count3 > count2 && (count3 > count1) && (count3 > count4) && (count3 > count5) && (count3 > count6) && (count3 > count7))
        cout << endl << endl << "Program response;" << endl << dataBaseSentence3;
    else if(count4 > count2 && (count4 > count3) && (count4 > count1) && (count4 > count5) && (count4 > count6) && (count4 > count7))
        cout << endl << endl << "Program response;" << endl << dataBaseSentence4;
    else if(count5 > count2 && (count5 > count3) && (count5 > count4) && (count5 > count1) && (count5 > count6) && (count5 > count7))
        cout << endl << endl << "Program response;" << endl << dataBaseSentence5;
    else if(count6 > count2 && (count6 > count3) && (count6 > count4) && (count6 > count5) && (count6 > count1) && (count6 > count7))
        cout << endl << endl << "Program response;" << endl << dataBaseSentence6;
    else if(count7 > count2 && (count7 > count3) && (count7 > count4) && (count7 > count5) && (count7 > count6) && (count7 > count1))
        cout << endl << endl << "Program response;" << endl << dataBaseSentence7;
}

void readSentence(std:: string direction, int amount){
    std::ofstream newLine("holdSentence.txt", fstream::app);
    if (!newLine) { std::cerr<<"file error\n"; std::exit(1); }
    newLine << " " << direction << endl;
    newLine.close();
    std::ifstream fin1("holdSentence.txt", fstream::app), fin2("holdDatabase.txt", fstream::app);
    if (!fin1 || !fin2) { std::cerr<<"file error\n"; std::exit(1); }

    string temp1;
    string temp2;
    string temp3;
    int count = 0;

    getline(fin1, temp1);

    while( getline( fin2, temp2 ) ){
        if(temp1 == temp2 && count == 0){
            count++;
        }
        else if(temp1 == temp2 && count > 0){
            count++;
        }
    }
    fin1.close();
    fin2.close();

    std::ofstream fout("holdDatabase.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    if(count == 0){
        fout << temp1 << endl;
    }
    fout.close();
}

void writeSentence(std::string str){

    std::ofstream fout("holdSentence.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    char * writable = new char[str.size() + 1];
    std::copy(str.begin(), str.end(), writable);
    writable[str.size()] = '\0'; // don't forget the terminating 0

    if (strncmp(writable, " ", 1) == 0) {
        cout << writable[1];
        fout << writable[1];
    }
    else if (strncmp(writable, " ", 1) != 0 ) {
        cout << " " << writable;
        fout << " " << writable;
    }
    fout.close();
    delete[] writable;
}

// This plays the sound

void playSound(std::string note, std::string note2){
    CMelody songSound;

    if(note == gF[0]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }
    if(note == gF[1]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    if(note == gF[2]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    if(note == gF[3]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    if(note == gF[4]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }
    if(note == gF[5]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    if(note == gF[6]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    if(note == gF[7]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    if(note == gF[8]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == dF[0]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    if(note == dF[1]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    if(note == dF[2]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    if(note == dF[3]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    if(note == dF[4]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    if(note == dF[5]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    if(note == dF[6]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    if(note == dF[7]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    if(note == dF[8]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == aF[0]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    if(note == aF[1]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    if(note == aF[2]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    if(note == aF[3]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    if(note == aF[4]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    if(note == aF[5]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    if(note == aF[6]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    if(note == aF[7]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    if(note == aF[8]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == eF[0]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    if(note == eF[1]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    if(note == eF[2]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    if(note == eF[3]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    if(note == eF[4]){
        songSound.AddNote(keDS, ke8th + ke16th); // compare chord s
        writeSentence(note2);
        count_up++;
    }
    if(note == eF[5]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    if(note == eF[6]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    if(note == eF[7]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    if(note == eF[8]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == bF[0]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    if(note == bF[1]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    if(note == bF[2]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    if(note == bF[3]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    if(note == bF[4]){
        songSound.AddNote(keAS, ke16th); // compare chord a
        writeSentence(note2);
        count_straight++;
    }
    if(note == bF[5]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    if(note == bF[6]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    if(note == bF[7]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    if(note == bF[8]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == F[0]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    if(note == F[1]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    if(note == F[2]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    if(note == F[3]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    if(note == F[4]){
        songSound.AddNote(keF, ke8th); // compare chord g
        writeSentence(note2);
        count_down++;
    }
    if(note == F[5]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    if(note == F[6]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    if(note == F[7]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    if(note == F[8]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == C[0]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    if(note == C[1]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    if(note == C[2]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    if(note == C[3]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    if(note == C[4]){
        songSound.AddNote(keC, ke8th + ke16th); // compare chord l
        writeSentence(note2);
        count_up++;
    }
    if(note == C[5]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    if(note == C[6]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    if(note == C[7]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    if(note == C[8]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == G[0]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    if(note == G[1]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    if(note == G[2]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    if(note == G[3]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    if(note == G[4]){
        songSound.AddNote(keG, ke8th); // compare chord k
        writeSentence(note2);
        count_right_++;
    }
    if(note == G[5]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    if(note == G[6]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    if(note == G[7]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    if(note == G[8]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == D[0]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    if(note == D[1]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    if(note == D[2]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    if(note == D[3]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    if(note == D[4]){
        songSound.AddNote(keD, ke8th + ke16th); // compare chord u
        writeSentence(note2);
        count_up++;
    }
    if(note == D[5]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    if(note == D[6]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    if(note == D[7]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    if(note == D[8]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == A[0]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    if(note == A[1]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }
    if(note == A[2]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    if(note == A[3]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    if(note == A[4]){
        songSound.AddNote(keA, ke16th); // compare chord j
        writeSentence(note2);
        count_straight++;
    }
    if(note == A[5]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    if(note == A[6]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }
    if(note == A[7]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    if(note == A[8]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == E[0]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    if(note == E[1]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    if(note == E[2]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }
    if(note == E[3]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    if(note == E[4]){
        songSound.AddNote(keE, ke8th + ke16th); // compare chord r
        writeSentence(note2);
        count_upnD++;
    }
    if(note == E[5]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    if(note == E[6]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    if(note == E[7]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }
    if(note == E[8]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    //////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////

    if(note == B[0]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    if(note == B[1]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    if(note == B[2]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    if(note == B[3]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }
    if(note == B[4]){
        songSound.AddNote(keRest, ke16th); // compare chord o
        writeSentence(note2);
        count_around++;
    }
    if(note == B[5]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }
    if(note == B[6]){
        songSound.AddNote(keGS, ke16th); // compare chord b
        writeSentence(note2);
        count_left_++;
    }
    if(note == B[7]){
        songSound.AddNote(keCS, ke8th + ke16th); // compare chord h
        writeSentence(note2);
        count_up++;
    }
    if(note == B[8]){
        songSound.AddNote(keFS, ke8th); // compare chord x
        writeSentence(note2);
        count_right_++;
    }

    songSound.Play();
}

// These next twelve functions are used to find the pattern in the csv file.

void gFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {23, 18, 1, 7, 23, 7, 18, 1, 7};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << gF[i] << endl;
        }
    }

    fout.close();
}

void dFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {7, 0, 18, 1, 7, 1, 0, 18, 1};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << dF[i] << endl;
        }
    }

    fout.close();
}

void aFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {1, 6, 0, 18, 1, 18, 6, 0, 18};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << aF[i] << endl;
        }
    }

    fout.close();
}

void eFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {18, 11, 6, 0, 18, 0, 11, 6, 0};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << eF[i] << endl;
        }
    }

    fout.close();
}

void bFlat(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {0, 10, 11, 6, 0, 6, 10, 11, 6};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << bF[i] << endl;
        }
    }

    fout.close();
}

void F_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {6, 20, 10, 11, 6, 11, 20, 10, 11};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << F[i] << endl;
        }
    }

    fout.close();
}

void C_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {11, 9, 20, 10, 11, 10, 9, 20, 10};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << C[i] << endl;
        }
    }

    fout.close();
}

void G_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {10, 17, 9, 20, 10, 20, 17, 9, 20};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << G[i] << endl;
        }
    }

    fout.close();
}

void D_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {20, 14, 17, 9, 20, 9, 14, 17, 9};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << D[i] << endl;
        }
    }

    fout.close();
}

void A_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {9, 23, 14, 17, 9, 17, 23, 14, 17};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << A[i] << endl;
        }
    }

    fout.close();
}

void E_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {17, 7, 23, 14, 17, 14, 7, 23, 14};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << E[i] << endl;
        }
    }

    fout.close();
}

void B_(int letterNumber, const std::string& frequency) {
    std::ofstream fout("pattern_file_out.txt", fstream::app);
    if (!fout) { std::cerr<<"file error\n"; std::exit(1); }

    static const int frequency_indices[] = {14, 1, 7, 23, 14, 23, 1, 7, 23};

    for (int i = 0; i < 9; ++i) {
        if (letterNumber == (i + 1) && frequency == frequencies[frequency_indices[i]]) {
            fout << B[i] << endl;
        }
    }

    fout.close();
}

// This allows me to read the csv file a line at a time, I got it from the internet
void readCSV(std::istream &input, std::vector< std::vector<std::string> > &output){
	std::string csvLine;
	// read every line from the stream
	while( std::getline(input, csvLine) ){
		std::istringstream csvStream(csvLine);
		std::vector<std::string> csvColumn;
		std::string csvElement;
		// read every element from the line that is seperated by commas
		// and put it into the vector or strings
		while( std::getline(csvStream, csvElement, ',') ){
			csvColumn.push_back(csvElement);
		}
		output.push_back(csvColumn);
	}
}

void openCsv(){

    int itemnum = 0;
    // I read the csv file and find the patterns then write the results to the pattern text file
                std::fstream file("file_out.csv", ios::in);
                if (!file) { std::cerr<<"file error\n"; std::exit(1); }

                // typedef to save typing for the following object
                typedef std::vector< std::vector<std::string> > csvVector;
                csvVector csvData;

                readCSV(file, csvData);
                // print out read data to prove reading worked
                for(csvVector::iterator I = csvData.begin(); I != csvData.end(); ++I){
                    for(std::vector<std::string>::iterator J = I->begin(); J != I->end(); ++J){
                        itemnum++;
                        string T = *J;

                        gFlat(itemnum, T);
                        dFlat(itemnum, T);
                        aFlat(itemnum, T);
                        eFlat(itemnum, T);
                        bFlat(itemnum, T);
                        F_(itemnum, T);
                        C_(itemnum, T);
                        G_(itemnum, T);
                        D_(itemnum, T);
                        A_(itemnum, T);
                        E_(itemnum, T);
                        B_(itemnum, T);
                    }

                itemnum = 0;

                }
                // I close the csv file
                file.close();
}

int main()
{
    std::ofstream aSentence("file_out.txt");
    if (!aSentence) { std::cerr<<"file error\n"; std::exit(1); }
    char theSentence[4096];
    cout << "Enter your sentence, end it with a period: ";
    cin.getline (theSentence,4096);
    aSentence << theSentence;
    aSentence.close();

    std::ifstream in("file_out.txt");
    std::ofstream fin3("holdSentence.txt");
    if (!in || !fin3) { std::cerr<<"file error\n"; std::exit(1); }
    fin3.close();

    string temp;
    float c_;
    int itemnum = 0;
    bool word = false;
    char letters[] = "abcdefghijklmnopqrstuvwxyz";
    float freqs[] = {466.16, 415.30, 415.30, 415.30, 415.30, 415.30, 349.23, 277.18,
    349.23, 440, 392, 261.63, 261.63, 349.23, 493.88, 261.63, 261.63, 329.63, 311.13,
    415.30, 293.66, 415.30, 311.13, 369.99, 392, 392};
    char *this_letter;
    int letter_index;

    // I convert the input to musical frequency values
    getline( in, temp );

    for (unsigned int a=0;a < temp.length();a++){
        if ( temp[a] == '.' || temp[a] == '?' || temp[a] == '!'){

            temp[a] = '\n';
            // I open then close the file to erase the previous text
            std::ofstream pattern("pattern_file_out.txt");
            pattern.close();

            std::ifstream fin("file_out.txt");
            std::ofstream fout2("file_out.csv");
            std::ofstream fout_3("file_out_2.txt");
            if (!fin || !fout2 || !fout_3) { std::cerr<<"file error\n"; std::exit(1); }

            while ((c_ = fin.get()) != EOF) {
                if (c_ == '\'') continue; // skip apostrophe
                if (std::isalpha(c_)) {
                    if (word) fout_3<<" ";
                    if (word) fout2<<',';

                    if ((this_letter = strchr(letters, tolower(c_))) != NULL){
                        fout_3 << this_letter[0] << endl;
                        letter_index = this_letter - letters;
                        c_ = freqs[letter_index];
                    }

                    fout2 << c_;
                    word = true;
                }

                else if (word) {
                    fout2<<'\n';
                    word = false;
                }
            }

            fin.close();
            fout2.close();
            fout_3.close();

        }
    }

    in.close();

    openCsv();

    cout << endl << "Input sentence to program, from input.txt;" << endl;
    // Now I take the text and make it into a sound

    std::ifstream inputDesign("pattern_file_out.txt");
    std::ifstream inputChar("file_out_2.txt");
    if (!inputDesign || !inputChar) { std::cerr<<"file error\n"; std::exit(1); }

    vector<string> text_file1;
    string temp1;
    string temp2;
    while( getline( inputDesign, temp1), getline( inputChar, temp2) ){
        string note;
        string note2;
        note = temp1;
        note2 = temp2;

        playSound(note, note2);

        text_file1.push_back( temp1 );
    }

    inputDesign.close();
    inputChar.close();

    if(count_up > count_upnD && (count_up > count_down) && (count_up > count_right_) && (count_up > count_left_) && (count_up > count_straight) && (count_up > count_around))
        readSentence("1", count_up);
    else if(count_upnD > count_up && (count_upnD > count_down) && (count_upnD > count_right_) && (count_upnD > count_left_) && (count_upnD > count_straight) && (count_upnD > count_around))
        readSentence("2", count_upnD);
    else if(count_down > count_upnD && (count_down > count_up) && (count_down > count_right_) && (count_down > count_left_) && (count_down > count_straight) && (count_down > count_around))
        readSentence("3", count_down);
    else if(count_right_ > count_upnD && (count_right_ > count_down) && (count_right_ > count_up) && (count_right_ > count_left_) && (count_right_ > count_straight) && (count_right_ > count_around))
        readSentence("4", count_right_);
    else if(count_left_ > count_upnD && (count_left_ > count_down) && (count_left_ > count_right_) && (count_left_ > count_up) && (count_left_ > count_straight) && (count_left_ > count_around))
        readSentence("5", count_left_);
    else if(count_straight > count_upnD && (count_straight > count_down) && (count_straight > count_right_) && (count_straight > count_left_) && (count_straight > count_up) && (count_straight > count_around))
        readSentence("6", count_straight);
    else if(count_around > count_upnD && (count_around > count_down) && (count_around > count_right_) && (count_around > count_left_) && (count_around > count_straight) && (count_around > count_up))
        readSentence("7", count_around);

    findMatch();
    cout << endl << endl;

    // I pause the console window so you can read the screen results
    system ("pause");
}
